package com.fp.persistence.pgeneral.acco;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEACCOUNTLIQUIDATION*/
@Entity(name="TgeneAccountLiquidation")
@Table(name="TGENEACCOUNTLIQUIDATION")
public class TgeneAccountLiquidation extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneAccountLiquidation
*/
@EmbeddedId
private TgeneAccountLiquidationKey pk;
@Column(name="BASEAMOUNTBALANCETYPE", nullable=true)

/**
* Tipo de saldo del cual se toma el monto para calcular el tarifario.
*/
private String baseamountbalancetype;

@Column(name="BASEAMOUNTBALANCEGROUP", nullable=true)

/**
* Grupo de balance del tipo de saldo del cual se toma el monto para calcular el tarifario.
*/
private String baseamountbalancegroup;

@Column(name="CALCULATEORDER", nullable=true)

/**
* CALCULATEORDER
*/
private Integer calculateorder;

@Column(name="NEGOTIABLE", nullable=true)

/**
* Indica si la tasa se puede negociar con el cliente el valor y las condiciones del cargo
*/
private String negotiable;

@Column(name="INCREASE", nullable=true)

/**
* Indica que incrementa el valor de capital con el cual se genera la tabla de pagos
*/
private String increase;

@Column(name="DECREASE", nullable=true)

/**
* Indica que disminuye el valor de capital con el cual se genera la tabla de pagos
*/
private String decrease;

@Column(name="DECREASEDISBURSEMENT", nullable=true)

/**
* Indica que el valor del cargo se descuenta del monto a entregar al cliente
*/
private String decreasedisbursement;

@Column(name="CASH", nullable=true)

/**
* Indica que el valor se cobra en efectivo.
*/
private String cash;

@Column(name="DEBITACCOUNT", nullable=true)

/**
* Indica que el valor se cobra con debito a una cuneta, esta puede ser cuenta contable o cuenta a la vista
*/
private String debitaccount;

@Column(name="VALUE", nullable=true)

/**
* Valor del cargo en la moneda de la operacion
*/
private BigDecimal value;

/**Contructor por defecto*/
public TgeneAccountLiquidation(){
}
/**Contructor de TgeneAccountLiquidation
@param pPk Clave Primaria del entity
*/
public TgeneAccountLiquidation(TgeneAccountLiquidationKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneAccountLiquidation
*/
public static TgeneAccountLiquidation find(EntityManager pEntityManager,TgeneAccountLiquidationKey pKey) throws Exception{
    TgeneAccountLiquidation obj = pEntityManager.find(TgeneAccountLiquidation.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneAccountLiquidation
@return El objeto que referencia a la Clave primaria de TgeneAccountLiquidation
*/
public TgeneAccountLiquidationKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneAccountLiquidation
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneAccountLiquidation
*/
public void setPk(TgeneAccountLiquidationKey pPk){
  pk=pPk;
}
/**Obtiene el valor de baseamountbalancetype
@return valor de baseamountbalancetype*/
public String getBaseamountbalancetype(){
  return baseamountbalancetype;
}
/**Fija el valor de baseamountbalancetype
@param pBaseamountbalancetype nuevo Valor de baseamountbalancetype*/
public void setBaseamountbalancetype(String pBaseamountbalancetype){
  baseamountbalancetype=pBaseamountbalancetype;
}

/**Obtiene el valor de baseamountbalancegroup
@return valor de baseamountbalancegroup*/
public String getBaseamountbalancegroup(){
  return baseamountbalancegroup;
}
/**Fija el valor de baseamountbalancegroup
@param pBaseamountbalancegroup nuevo Valor de baseamountbalancegroup*/
public void setBaseamountbalancegroup(String pBaseamountbalancegroup){
  baseamountbalancegroup=pBaseamountbalancegroup;
}

/**Obtiene el valor de calculateorder
@return valor de calculateorder*/
public Integer getCalculateorder(){
  return calculateorder;
}
/**Fija el valor de calculateorder
@param pCalculateorder nuevo Valor de calculateorder*/
public void setCalculateorder(Integer pCalculateorder){
  calculateorder=pCalculateorder;
}

/**Obtiene el valor de negotiable
@return valor de negotiable*/
public String getNegotiable(){
  return negotiable;
}
/**Fija el valor de negotiable
@param pNegotiable nuevo Valor de negotiable*/
public void setNegotiable(String pNegotiable){
  negotiable=pNegotiable;
}

/**Obtiene el valor de increase
@return valor de increase*/
public String getIncrease(){
  return increase;
}
/**Fija el valor de increase
@param pIncrease nuevo Valor de increase*/
public void setIncrease(String pIncrease){
  increase=pIncrease;
}

/**Obtiene el valor de decrease
@return valor de decrease*/
public String getDecrease(){
  return decrease;
}
/**Fija el valor de decrease
@param pDecrease nuevo Valor de decrease*/
public void setDecrease(String pDecrease){
  decrease=pDecrease;
}

/**Obtiene el valor de decreasedisbursement
@return valor de decreasedisbursement*/
public String getDecreasedisbursement(){
  return decreasedisbursement;
}
/**Fija el valor de decreasedisbursement
@param pDecreasedisbursement nuevo Valor de decreasedisbursement*/
public void setDecreasedisbursement(String pDecreasedisbursement){
  decreasedisbursement=pDecreasedisbursement;
}

/**Obtiene el valor de cash
@return valor de cash*/
public String getCash(){
  return cash;
}
/**Fija el valor de cash
@param pCash nuevo Valor de cash*/
public void setCash(String pCash){
  cash=pCash;
}

/**Obtiene el valor de debitaccount
@return valor de debitaccount*/
public String getDebitaccount(){
  return debitaccount;
}
/**Fija el valor de debitaccount
@param pDebitaccount nuevo Valor de debitaccount*/
public void setDebitaccount(String pDebitaccount){
  debitaccount=pDebitaccount;
}

/**Obtiene el valor de value
@return valor de value*/
public BigDecimal getValue(){
  return value;
}
/**Fija el valor de value
@param pValue nuevo Valor de value*/
public void setValue(BigDecimal pValue){
  value=pValue;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneAccountLiquidation))return false;
    TgeneAccountLiquidation that = (TgeneAccountLiquidation) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneAccountLiquidation
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneAccountLiquidation
*/
public Object createInstance(){
 TgeneAccountLiquidation instance=new TgeneAccountLiquidation();	
 instance.setPk(new TgeneAccountLiquidationKey());
 return instance;
}
/**Clona la entidad TgeneAccountLiquidation
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneAccountLiquidation p=(TgeneAccountLiquidation)this.clone();
  p.setPk((TgeneAccountLiquidationKey)this.pk.cloneMe());
  return p;
}

	//Metodos manuales.
	/**Sentencia que devuelve uan lista de cargos de liquidacion asociados a una cuenta.*/
	private static final String HQL_ACCO_LIQUIDATION =
	" from TgeneAccountLiquidation t  " +
	" where t.pk.account = :account "+
	" and t.pk.company = :company ";

	/**
	 * Metodo que entrega una lista de valores a entregar al cliente, en la aperturad e una operacion. 
	 * @param pAccount	Numero de cuenta. 
	 * @param pCompany	Codigo de compania a la que pertenece la cuenta. 
	 * @return	List<TgeneAccountLiquidation>
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public static List<TgeneAccountLiquidation> find(EntityManager pEntityManager,
			String pAccount,Integer pCompany) throws Exception {
		List<TgeneAccountLiquidation>  lObjects = null;
		Query qry = pEntityManager.createQuery(HQL_ACCO_LIQUIDATION);
		qry.setParameter("account", pAccount);
		qry.setParameter("company", pCompany);
		lObjects = qry.getResultList();	
		return lObjects;
	}

}
